VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "MSWINSCK.OCX"
Begin VB.Form Form1 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "NISTTimeSet, Time Adjustment Example"
   ClientHeight    =   3855
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4590
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3855
   ScaleWidth      =   4590
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.Timer Timer2 
      Interval        =   1000
      Left            =   120
      Top             =   1140
   End
   Begin VB.CommandButton Command3 
      Caption         =   "Make System Time 90s slow for Test "
      Height          =   375
      Left            =   128
      TabIndex        =   6
      Top             =   3360
      Width           =   2835
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Close"
      Height          =   375
      Left            =   3248
      TabIndex        =   5
      Top             =   3360
      Width           =   1215
   End
   Begin VB.TextBox Text2 
      Alignment       =   2  'Center
      Height          =   285
      Left            =   248
      TabIndex        =   4
      Text            =   "Time String Not Yet Received"
      Top             =   2040
      Width           =   4035
   End
   Begin VB.TextBox Text1 
      Alignment       =   2  'Center
      Height          =   315
      Left            =   1411
      TabIndex        =   1
      Text            =   "NIST Address"
      Top             =   480
      Width           =   1755
   End
   Begin VB.Timer Timer1 
      Left            =   120
      Top             =   180
   End
   Begin MSWinsockLib.Winsock Winsock1 
      Left            =   120
      Top             =   660
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Set Time Accurately from Time Server"
      Height          =   375
      Left            =   728
      TabIndex        =   0
      Top             =   1440
      Width           =   3075
   End
   Begin VB.Label Label4 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      Height          =   195
      Left            =   2258
      TabIndex        =   8
      Top             =   120
      Width           =   75
   End
   Begin VB.Label Label3 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      Caption         =   "Sytem Time has Not been Set Yet"
      Height          =   195
      Left            =   1088
      TabIndex        =   7
      Top             =   2940
      Width           =   2415
   End
   Begin VB.Label Label2 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      Caption         =   "Time After Adjustment"
      Height          =   195
      Left            =   1538
      TabIndex        =   3
      Top             =   2520
      Width           =   1575
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      Caption         =   "Time Before Adjustment"
      Height          =   195
      Left            =   1493
      TabIndex        =   2
      Top             =   1020
      Width           =   1695
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'#######################################################
'*******************************************************
'Simple but very accurate time setting using Winsock
'By Joe Sova
'jsova@twmi.rr.com
'Copyright(c) 2003 'Just kidding
'Use at your own risk!
'Copy, mutilate, distribute, change and otherwise abuse
'Only real requirement is that you learn, learn, learn!
'*******************************************************
'#######################################################

'Wait 2 seconds between time settings else the server may not respond

'Timer1 gives the server 5 seconds to respond, else time setting is aborted
'Timer2 updates the current time on Form1 each second

'The program checks for three conditions of invalid time, aborts if not valid
'1) The string that was received from the server is not of the proper format
'2) If the server reports it's own condition to be bad
'3) If for some reason 'SetSystemTime' returns an error it will try upt to 10
'more times to set the time else it aborts

'This program requires that the local computer has it's timezone set correctly
'as the time the server sends is always UTC or a timezone of 0
'Daylight saving time is also the responsibility of the local computer

'The accuracy of this program, as far as I can tell from other programs that
'measure such things is +/- 100ms of perfect time a very impressive result!

'Finally
'This program sets the system time by directly modifying the SetSystemTime SYSTEMTIME data structure
'Microsoft apparently does not recommend doing it this way,
'see http://msdn.microsoft.com/library/default.asp?url=/library/en-us/sysinfo/base/systemtime_str.asp
'Microsoft says... "It is not recommended that you add and subtract values from
'the SYSTEMTIME structure to obtain relative times.
'Instead, you should Convert the SYSTEMTIME structure to a FILETIME structure.
'Copy the resulting FILETIME structure to a ULARGE_INTEGER structure.
'Use normal 64-bit arithmetic on the ULARGE_INTEGER value."

'Then I would assume that after the 64-bit math is added, all the above steps would need to be reversed.

'If anyone successfully does this the 'correct' way, please send me a 'how to'
'Thanks So much
'-Joe

Private Declare Function SetSystemTime Lib "kernel32" (lpSystemTime As SYSTEMTIME) As Long 'sets system time when arrives from server

Private Type SYSTEMTIME
   wYear As Integer
   wMonth As Integer
   wDayOfWeek As Integer
   wDay As Integer
   wHour As Integer
   wMinute As Integer
   wSecond As Integer
   wMilliseconds As Integer
End Type

Private msAdj As Integer
Private SetIt As Integer

Private Sub Command1_Click() 'Main button to set the system time
    On Error GoTo ErrHandler

    Label3.Caption = "System Time has Not been Set Yet"

    SetIt = 1 'Used to only set time if the time from the time server is valid and reportedly accurate

    If Winsock1.State <> sckClosing Then 'Sometimes the Winsock gets delayed in the closing state, so make sure it is closed before trying again
       If Winsock1.State = sckClosed Then 'If closed, ok to open, else close it
          Timer1.Interval = 5000 'Start 5 second count to 'time' server
          Timer1.Enabled = True
          Screen.MousePointer = vbHourglass
          Winsock1.LocalPort = 0 'Must be set to 0
          Winsock1.RemoteHost = Trim$(Text1.Text) 'Address of NIST server
          Winsock1.RemotePort = 13 '13, 37 or 123 'Use 13!
          Winsock1.Protocol = 0 '1-UDP '0-TCP 'USE TCP!
          Winsock1.Connect 'This is what goes out and gets the time
       Else
          Winsock1.Close
          Screen.MousePointer = vbNormal
          Timer1.Interval = 0
          Timer1.Enabled = False
       End If
    Else
       Winsock1.Close
       Screen.MousePointer = vbNormal
       Timer1.Interval = 0
       Timer1.Enabled = False
    End If
    
    Exit Sub
ErrHandler:
    SetIt = 0
    Screen.MousePointer = vbNormal
    Timer1.Interval = 0
    Timer1.Enabled = False
    MsgBox "The Winsock Connection is Unavailable."
    Winsock1.Close
End Sub

Private Sub Command2_Click() 'Properly close the project

Timer1.Interval = 0
Timer1.Enabled = False

Timer2.Interval = 0
Timer2.Enabled = False

Unload Me
Set Form1 = Nothing

End Sub

Private Sub Command3_Click() 'Temporarily set the time back 90s for testing

MsgBox "It is not recommended to ever set the system time to an incorrect value," & vbCrLf & _
"after running this test, make sure the system time is returned to the correct time.", vbExclamation

Time = DateAdd("s", -90, Now)
Label1.Caption = "Before " & Now
Label2.Caption = "Time After Adjustment"

End Sub

Private Sub Form_Load()

'All these servers are valid for this system
'  ADDRESS              NAME                            LOCATION
'****************************************************************************
'128.138.140.44    utcnist.colorado.edu           University of CO, Boulder
'129.6.15.28       time-a.nist.gov                NIST, Gaithersburg, MD
'129.6.15.29       time-b.nist.gov                NIST, Gaithersburg, MD
'131.107.1.10      time-nw.nist.gov               Microsoft, Redmond, WA
'132.163.4.101     time-a.timefreq.bldrdoc.gov    NIST, Boulder, Colorado
'132.163.4.102     time-b.timefreq.bldrdoc.gov    NIST, Boulder, Colorado
'132.163.4.103     time-c.timefreq.bldrdoc.gov    NIST, Boulder, Colorado
'192.43.244.18     time.nist.gov                  NCAR, Boulder, Colorado
'205.188.185.33    nist1.aol-va.truetime.com      AOL TrueTime, Virginia
'207.126.98.204    nist1-sj.glassey.com           Abovenet, San Jose, CA
'207.200.81.113    nist1.aol-ca.truetime.com      AOL TT, Sunnyvale, CA
'208.184.49.9      nist1-ny.glassey.com           Abovenet, New York City
'216.200.93.8      nist1-dc.glassey.com           Abovenet, Virginia
'66.243.43.21      nist1.datum.com                Datum, San Jose, CA

'Also works just fine to use the name instead of the address in the text box but,
'it is not recommended 'cause the Name is likely to change although the address will not
Text1.Text = "192.43.244.18" 'time.nist.gov

End Sub

Private Sub Timer1_Timer() 'Server did not respond within 5 seconds

Winsock1.Close
Screen.MousePointer = vbNormal
Timer1.Interval = 0
Timer1.Enabled = False

MsgBox "There was no reponse from server, please wait 2 seconds and try again"

End Sub

Private Sub Timer2_Timer() 'Updates current time on Form1 each second
Label4.Caption = "Current Time is " & Now
End Sub

Private Sub Winsock1_Close() 'Fires when Winsock is closed

Screen.MousePointer = vbNormal
Timer1.Interval = 0
Timer1.Enabled = False

End Sub

Private Sub Winsock1_DataArrival(ByVal bytesTotal As Long) 'Fires when data is received from server
Dim datDate As Date 'formatted date
Dim strData As String 'time string from net time server
Dim JSys As SYSTEMTIME
Dim RetVal As Integer
Dim Ct As Integer

    On Error GoTo ErrHandler
    
    Winsock1.GetData strData, vbString 'get string from server
    datDate = FormatDateTime(strData) 'go format the new string
    
    If msAdj <> 0 Then 'if msadj = 0 then do not set an offset
       datDate = DateAdd("s", -1, datDate) 'only if msadj <> 0, subtract 1 sec from new time so addition of msadj is positive
    End If
    
    Label1.Caption = "Before " & Now 'time before adjustment
    
    If SetIt = 1 Then 'If all is ok, set system time
    
       'Initialize SYSTIME with new data
       JSys.wYear = Year(datDate)
       JSys.wMonth = Month(datDate)
       JSys.wDayOfWeek = 0 'DayOfWeek(datDate)'Not used
       JSys.wHour = Hour(datDate)
       JSys.wMinute = Minute(datDate)
       JSys.wSecond = Second(datDate)
       JSys.wDay = Day(datDate)
       
       If msAdj = 0 Then
          JSys.wMilliseconds = 0 'No millisec offset
       Else
          JSys.wMilliseconds = ((10000 - msAdj) / 10) 'must be positive
       End If

       ' Set system time with new data
' Modified by Rod, 11/7/03
'       Do Until RetVal <> 0 Or Ct > 9 'Make up to 10 attempts to set the time
          RetVal = SetSystemTime(JSys)
'          Ct = Ct + 1
'       Loop

       Label2.Caption = "After " & Now 'time after adjustment
       
       If RetVal <> 0 Then
          Label3.Caption = "System Time was Set Successfully"
       Else
          Label3.Caption = "There was an Error in Setting Time"
       End If

       'Display time string that was sent from server
       Text2.Text = strData
    End If
    
    SetIt = 0
    Winsock1.Close
    Screen.MousePointer = vbNormal
    Timer1.Interval = 0
    Timer1.Enabled = False
    
    Exit Sub
ErrHandler:
    SetIt = 0
    Winsock1.Close
    Screen.MousePointer = vbNormal
    Timer1.Interval = 0
    Timer1.Enabled = False
End Sub

Private Function FormatDateTime(ByRef NetTime As String) As Date 'format the string received from time server

Dim strDate As String
Dim strTime As String

'Received string example
'JJJJJ YR-MO-DA HH:MM:SS TT L H msADV UTC(NIST) OTM
'52587 02-11-12 22:05:25 00 0 0 636.1 UTC(NIST) *

'Extract the Date from the received string
strDate = Mid$(NetTime, 11, 5) & "-" & Mid$(NetTime, 8, 2)

'Extract the time from the received string
strTime = Mid$(NetTime, 17, 8)

'Check that extracts are suitable date and time - then convert using CDate
If IsDate(strDate) And IsDate(strTime) Then
   FormatDateTime = CDate(strDate & " " & strTime)
   
   'Extract the downloaded millisec time offset 'this is the transmission line time delay the server calculated and offset the time by
   msAdj = Val(Mid$(NetTime, 33, 3) + Mid$(NetTime, 37, 1))

   'Server health is bad, server actually reports it's own condition, do not set if bad
   If Mid$(NetTime, 31, 1) <> "0" Then 'is servers' health bad?, then do not set
      SetIt = 0 'do not set time
      MsgBox "This server reports it's time may not be accurate at the moment," & vbCrLf & _
      "therefore the system time was not set." & vbCrLf & vbCrLf & "Try another server or wait and try again."
   End If
Else
   'Date / time format is wrong
   SetIt = 0 'do not set time
   MsgBox "The data string from this server caused a Time and/or Date formatting error," & vbCrLf & _
   "therefore, the system time was not set." & vbCrLf & vbCrLf & "Try another server, for the moment or try again later."
End If
  
End Function

Private Sub Winsock1_Error(ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)

'I have found that this error only generates if a dial-up system is not connected
'Does not generate if an "Always on" cable modem is deactivated. -strange
MsgBox "An error occurred during an attempt to set your system time," & vbCrLf & "your dial-up connection may not be connected."

Winsock1.Close
Screen.MousePointer = vbNormal
Timer1.Interval = 0
Timer1.Enabled = False
SetIt = 0

End Sub
